//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dll_rw.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        hdll = 0;
        hdll = LoadLibrary("port.dll");


        if ( hdll == 0 )
                MessageBox( 0, "Can not load port.dll", "Error", MB_OK );
        SDA = ( void(__stdcall*)(DWord wBit)) GetProcAddress( hdll, "DTR" );
        SCL = ( void(__stdcall*)(DWord wBit)) GetProcAddress( hdll, "RTS" );
        In_SDA = ( int(__stdcall*)(void)) GetProcAddress( hdll, "DSR" );
        rsOpen = ( void(__stdcall*)(AnsiString asCom))
                                GetProcAddress( hdll, "OPENCOM");
        dTime = ( void(__stdcall*)(DWORD dWait)) GetProcAddress( hdll, "DELAYUS" );

        wDTR = 0x0;
        wRTS = 0x0;
        dwCount = 0x0;

        Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
//      Schnittstelle ffnen
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
       OpenComPort();
}
//---------------------------------------------------------------------------
//      Anwendung schliesen
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        Timer1->Enabled = false;
         
        if( hdll != 0 )
                FreeLibrary(hdll);
}
//---------------------------------------------------------------------------
// Daten auf den I2C Bus schreiben
//---------------------------------------------------------------------------
void TForm1::WriteI2C( DWORD Addr ,DWORD Data )
{

        // Start
        SDA( 0x0 );
        WaitTime(1);
        SCL( 0x0 );
        WaitTime(1);

        asTXT = "Start";
        // Adresse ausgeben
        WriteData( Addr );   // 64  , 112
        asTXT += "Adr:";
        // Daten ausgeben
        WriteData( Data);
        asTXT += "Data:";

        // Stop
        SCL( 0x1 );
        WaitTime(1);
        SDA( 0x1 );
        asTXT += "Ende";

        StatusBar1->SimpleText = asTXT;

}
//---------------------------------------------------------------------------
//      Button Write Data bearbeiten
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonWriteClick(TObject *Sender)
{
        WriteAdr();

}
//---------------------------------------------------------------------------
// Zeitverzgerung in 1 ms
//---------------------------------------------------------------------------
void TForm1::WaitTime( int nMs )
{
        Sleep( 1 );
}
//---------------------------------------------------------------------------
//      8 Bit auf den I2C - Bus schreiben
//---------------------------------------------------------------------------
int TForm1::WriteData( DWORD Data )
{
        unsigned char BitWert = 128;
        unsigned char nUnd;

        for( int n = 0; n < 8; n++ )
        {
                nUnd = BitWert & Data;
                if(  nUnd != 0 )
                {
                        SDA( 0x1 );
                        asTXT += "1";
                }
                else
                {
                        SDA( 0x0 );
                        asTXT += "0";
                }
                SCL( 0x1 );
                WaitTime(1);
                SCL( 0x0 );
                WaitTime(1);

              //  Delay();
                BitWert /= 2;
        }
        SCL( 0x0 );
        SDA( 0x1 );
        WaitTime(1);

        SCL( 0x1 );
        asTXT += "ACK";

        int n = 0;
        int c = 0;
        for( c = 0; c < 10; c++ )
        {
                n = In_SDA();
                if( n == 0 ) break;
        }
        asTXT += "->c =" + IntToStr( c ) + "<-";

        SDA( 0x1 );
        SCL( 0x0 );
        WaitTime(1);
        return 0;
}
//---------------------------------------------------------------------------
//      Schnittstelle ffnen und Grundstellung I2C - Bus
//---------------------------------------------------------------------------
void TForm1::OpenComPort( void )
{
       if( RadioCom1->Checked == true )
       {
                rsOpen("com1:9600,N,8,1");
                nCom = 1;
       }
       else
       {
                rsOpen("com2:9600,N,8,1");
                nCom = 2;
       }

       Button1->Enabled = false;
       SDA( 0x1 );
       SCL( 0x1 );
}
//---------------------------------------------------------------------------
//      Ausgewhlte Adresse ermitteln
//---------------------------------------------------------------------------
DWORD TForm1::SetI2CAdr( void )
{
        DWORD dSetAdr = 0x40;

        // Basisadresse abfragen
        int nCount = ComboBox1->ItemIndex;
        switch( nCount )
        {
                case 0 : dSetAdr = 0x40; break;
                case 1 : dSetAdr = 0x70; break;
//                case 2 : dSetAdr = 0x40; break;
                default : dSetAdr = 0x40; break;
        }

        // Adressbits setzen
        nCount = ComboBox2->ItemIndex;
        switch( nCount )
        {
                case 0: break;
                case 1: dSetAdr += 2; break;
                case 2: dSetAdr += 4; break;
                case 3: dSetAdr += 6; break;
                case 4: dSetAdr += 8; break;
                case 5: dSetAdr += 10; break;
                case 6: dSetAdr += 12; break;
                case 7: dSetAdr += 14; break;
                default : break;
        }

        return dSetAdr;
}
//---------------------------------------------------------------------------
//      Bearbeitung Read Data Button
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonReadClick(TObject *Sender)
{
        ReadInp();
}
//---------------------------------------------------------------------------
//      Eingnge ber den I2C - Bus lesen
//---------------------------------------------------------------------------
void TForm1::ReadI2C( DWORD Addr )
{
        DWORD rdData = 0x0;
        // Start
        SDA( 0x0 );
        WaitTime(1);
        SCL( 0x0 );
        WaitTime(1);

        asTXT = "Start";
        // Adresse ausgeben
        WriteData( Addr + 1 );   // 64  , 112
        asTXT += "Adr:";

        // Daten einlesen
        rdData = ReadData();
        asTXT += "Dataread";

        // Stop
        SCL( 0x1 );
        WaitTime(1);
        SDA( 0x1 );
        asTXT += "Ende";

        StatusBar1->SimpleText = asTXT;
}
//---------------------------------------------------------------------------
//      8 Bit ber den I2C - Bus lesen
//---------------------------------------------------------------------------
DWORD TForm1::ReadData( void )
{

        unsigned char BitWert = 128;
        AnsiString asData = "";
        DWORD Data = 0;
        int nInBit;

        SCL( 0x0 );

        for( int n = 8; n > 0; n-- )
        {
                nInBit = 0;
                SCL( 0x1 );
                WaitTime(1);

                nInBit = In_SDA();
                asData += IntToStr( nInBit );
                nInBit << n;
                Data =+ nInBit;


                SCL( 0x0 );
                WaitTime(1);

              //  Delay();
                BitWert /= 2;
        }

        // Kein ACK
        SCL( 0x0 );
        SDA( 0x1 );
        SCL( 0x1 );
        WaitTime(1);
        SCL( 0x0 );


        Edit1->Text = asData + " -> " + IntToStr( AStringDualToInt( asData ) );
        asTest += asData + " -> " + IntToStr( AStringDualToInt( asData ) );
        return Data;
}
//---------------------------------------------------------------------------
//      Kontrolle , ob CheckBoxCount ausgewhlt ist
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBoxCountClick(TObject *Sender)
{
        if( CheckBoxCount->Checked == true )
        {
                        ButtonWrite->Enabled = false;
                        CheckBoxRead->Checked = false;
                        Timer1->Enabled = true;
        }
        else
        {
                        Timer1->Enabled = false;
                        ButtonWrite->Enabled = true;
        }

}
//---------------------------------------------------------------------------
//      Timerfunktionen
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        // Ausgnge der Reihe nach setzen
        if( CheckBoxCount->Checked == true )
        {

                CheckBoxRead->Checked = false;
                if ( dwCount == 0 ) dwCount = 1;
                else dwCount = dwCount + dwCount;

                Edit2->Text = IntToStr( dwCount );
                WriteAdr();

                if( dwCount >= 128 ) dwCount = 0;
        }
        // Eingnge abfragen
        if( CheckBoxRead->Checked == true )
        {
                ReadInp();
        }
}
//---------------------------------------------------------------------------
//      Auf Ausgnge schreiben
//---------------------------------------------------------------------------
void TForm1::WriteAdr( void )
{
        if ( nCom == 0 )
                        OpenComPort();

        DWORD dwData = StrToInt( Edit2->Text );
        if( dwData > 256 )
        {
                Application->MessageBoxA( "Error", "Data is to big", MB_OK );
                dwData = 0x0;
        }

       // 8 Bit
       WriteI2C( SetI2CAdr(), dwData );
}
//---------------------------------------------------------------------------
// Funktion konvertiert ein AnsiString 8 Bit Dualwert in ein Int.
//---------------------------------------------------------------------------
int TForm1::AStringDualToInt( AnsiString asDual )
{
        int nlen = asDual.Length();
        if( nlen > 8 )
        {
                Application->MessageBoxA( "Error", "Data is longer than 8 bits",
                 MB_OK );
                 return 0;
        }
        return 0;
}

//---------------------------------------------------------------------------
//      Eingnge ber den I2C lesen
//---------------------------------------------------------------------------
DWORD TForm1::ReadDataACK( void )
{
        unsigned char BitWert = 128;
        AnsiString asData = "";
        DWORD Data = 0;
        int nInBit;

        SCL( 0x0 );

        for( int n = 8; n > 0; n-- )
        {
                nInBit = 0;
                SCL( 0x1 );
                WaitTime(1);

                nInBit = In_SDA();
                asData += IntToStr( nInBit );
                nInBit << n;
                Data =+ nInBit;


                SCL( 0x0 );
                WaitTime(1);

              //  Delay();
                BitWert /= 2;
        }

        SCL( 0x0 );
        SDA( 0x1 );
        WaitTime(1);

        SCL( 0x1 );
        asTXT += "ACK";

        int n = 0;
        int c = 0;
        for( c = 0; c < 10; c++ )
        {
                n = In_SDA();
                if( n == 0 ) break;
        }
        asTXT += "->c =" + IntToStr( c ) + "<-";

        SDA( 0x1 );
        SCL( 0x0 );
        WaitTime(1);

        asTest += asData + " -> " + IntToStr( AStringDualToInt( asData ) ) + ";";
        Edit1->Text = asData + " -> " + IntToStr( AStringDualToInt( asData ) );
        return Data;
}
//---------------------------------------------------------------------------
//      Eingnge lesen
//---------------------------------------------------------------------------
void TForm1::ReadInp( void )
{
        if ( nCom == 0 )
                        OpenComPort();

        // Zur Sicherheit erst alle Ausgnge auf High setzen
        Edit2->Text = "255";
        WriteAdr();
        // 8 Bit
        ReadI2C( SetI2CAdr());
}

//---------------------------------------------------------------------------
//      Eingnge automatisch lesen
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBoxReadClick(TObject *Sender)
{
        if( CheckBoxRead->Checked == true )
        {
                        ButtonRead->Enabled = false;
                        CheckBoxCount->Checked = false;
                        Timer1->Enabled = true;
        }
        else
        {
                        Timer1->Enabled = false;
                        ButtonRead->Enabled = true;
        }

}
//---------------------------------------------------------------------------

